import template from 'babel-template';
import generate from '@babel/generator';
import { parse } from 'babylon';
import path from 'path';

var nodePath = path;
process.env.BABEL_DISABLE_CACHE = '1'; // import generate from 'babel-generator';
// var [IMPORT_NAME] = require(SOURCE);
//   var ____useWhatChanged = IMPORT_NAME.useWhatChanged

/**
 *
 * Check whether the dependency item is an object. then
 */

var isObject = function isObject(t) {
  return Object.prototype.toString.call(t) === '[object Object]';
};

var buildRequire =
/*#__PURE__*/
template("\n  var IMPORT_NAME = require(SOURCE);\n  var ____useWhatChanged = IMPORT_NAME.useWhatChanged\n");
var SetToSupport = ['useEffect', 'useCallback', 'useMemo', 'useLayoutEffect'];

function transformCode(_ref) {
  var lineNo = _ref.lineNo,
      state = _ref.state,
      path = _ref.path;
  // console.log('TCL: Identifier -> lineNoWhereCallNeedToBeAdded', lineNo);
  var parentMemberCallExpression = path.findParent(function (path) {
    return path.isCallExpression();
  });

  if (!parentMemberCallExpression) {
    // return is the it is not a call expression
    return;
  }

  var bodyPath = path.findParent(function (path) {
    return path.parent.type === 'BlockStatement';
  });
  var parentNode = parentMemberCallExpression.node;
  var dependencyArgs = parentNode.arguments[1];

  if (dependencyArgs) {
    if (dependencyArgs.type === 'ArrayExpression' // dependencyArgs.elements.length > 0
    ) {
        var collectedNames = generate(dependencyArgs, {
          shouldPrintComment: function shouldPrintComment() {
            return false;
          }
        }).code; // const parsedPath = nodePath.parse(state.file.opts.filename);
        // console.log('current working directory', path.node.loc.start.line);
        // const currentWorkingDirectory = nodePath
        //   .dirname(state.file.opts.filename)
        //   .split(nodePath.sep)
        //   .pop();

        var splittedPath = state.file.opts.filename.split(nodePath.sep);
        var templateuseWhatChangedFUnctionCall = "\n       ____useWhatChanged(" + collectedNames + ",\"" + collectedNames.slice(1, -1) + "\", \"" + path.node.name + "::" + splittedPath.slice(-2).join('/') + "\")\n       ";
        var useWhatChangedAst = parse(templateuseWhatChangedFUnctionCall);

        if (state.lineNoWhereCallNeedToBeAdded && state.lineNoWhereCallNeedToBeAdded[lineNo]) {
          state.lineNoWhereCallNeedToBeAdded[lineNo].collectionNames = collectedNames;
        }

        try {
          // path.unshiftContainer('body', useWhatChangedAst);
          bodyPath.insertBefore(useWhatChangedAst);
        } catch (e) {
          console.error('@simbathesailor-uwc-debug error', e);
        }

        if (state.lineNoWhereCallNeedToBeAdded && state.lineNoWhereCallNeedToBeAdded[lineNo]) {
          state.lineNoWhereCallNeedToBeAdded[lineNo].done = true;
        }
      }
  }
}

function Test(babel) {
  var t = babel.types;
  return {
    visitor: {
      Identifier: function Identifier(path, state) {
        console.log('Identifier -> path', path);
        if (!state.opts.active) return;

        if (SetToSupport.indexOf(path.node.name) !== -1 // isObject(state.lineNoWhereCallNeedToBeAdded)
        ) {
            var _path$node, _path$node$loc, _path$node$loc$start;

            // Handling the uwc-debug-below
            if (state.lowerlimituwcdebug !== undefined && parseInt(path === null || path === void 0 ? void 0 : (_path$node = path.node) === null || _path$node === void 0 ? void 0 : (_path$node$loc = _path$node.loc) === null || _path$node$loc === void 0 ? void 0 : (_path$node$loc$start = _path$node$loc.start) === null || _path$node$loc$start === void 0 ? void 0 : _path$node$loc$start.line, 10) > state.lowerlimituwcdebug) {
              var lineToInsert = parseInt(path.node.loc.start.line, 10) - 1;
              transformCode({
                lineNo: lineToInsert,
                path: path,
                state: state
              });

              if (!state.lineNoWhereCallNeedToBeAdded) {
                state.lineNoWhereCallNeedToBeAdded = {};
              }

              if (!state.lineNoWhereCallNeedToBeAdded[lineToInsert]) {
                var _state$lineNoWhereCal;

                state.lineNoWhereCallNeedToBeAdded = (_state$lineNoWhereCal = {}, _state$lineNoWhereCal[lineToInsert] = {
                  done: false
                }, _state$lineNoWhereCal);
              }

              state.lineNoWhereCallNeedToBeAdded[lineToInsert].done = true;
            }

            if (isObject(state.lineNoWhereCallNeedToBeAdded)) {
              Object.keys(state.lineNoWhereCallNeedToBeAdded).forEach(function (lineNo) {
                if (!state.lineNoWhereCallNeedToBeAdded[lineNo].done) {
                  var _path$node2, _path$node2$loc, _path$node2$loc$start;

                  if (parseInt(path === null || path === void 0 ? void 0 : (_path$node2 = path.node) === null || _path$node2 === void 0 ? void 0 : (_path$node2$loc = _path$node2.loc) === null || _path$node2$loc === void 0 ? void 0 : (_path$node2$loc$start = _path$node2$loc.start) === null || _path$node2$loc$start === void 0 ? void 0 : _path$node2$loc$start.line, 10) === parseInt(lineNo) + 1) {
                    transformCode({
                      lineNo: lineNo,
                      state: state,
                      path: path
                    });
                  }
                }
              });
            }
          }
      },
      Program: {
        exit: function exit() {},
        enter: function enter(path, state) {
          var uwcDebugBelowEncountered = false;
          if (!state.opts.active) return;

          try {
            path.container.comments.forEach(function (commentObj) {
              if (commentObj.value.trim() === 'uwc-debug') {
                if (!state.isDoneAddingImport) {
                  var ast = buildRequire({
                    IMPORT_NAME: t.identifier('simbathesailor_useWhatChangedImport'),
                    SOURCE: t.stringLiteral('@simbathesailor/use-what-changed')
                  });

                  try {
                    path.unshiftContainer('body', ast);
                  } catch (e) {
                    console.error('@simbathesailor-uwc-debug error adding import', e);
                  }

                  state.isDoneAddingImport = true;
                }

                if (isObject(state) && isObject(state.lineNoWhereCallNeedToBeAdded)) {
                  var _Object$assign;

                  state.lineNoWhereCallNeedToBeAdded = Object.assign({}, state.lineNoWhereCallNeedToBeAdded, (_Object$assign = {}, _Object$assign[commentObj.loc.start.line] = {
                    done: false
                  }, _Object$assign));
                } else {
                  var _state$lineNoWhereCal2;

                  state.lineNoWhereCallNeedToBeAdded = (_state$lineNoWhereCal2 = {}, _state$lineNoWhereCal2[commentObj.loc.start.line] = {
                    done: false
                  }, _state$lineNoWhereCal2);
                }
              } // Need to add logic for uwc-debug-below


              if (commentObj.value.trim() === 'uwc-debug-below' && !uwcDebugBelowEncountered) {
                ////
                if (!state.isDoneAddingImport) {
                  var _ast = buildRequire({
                    IMPORT_NAME: t.identifier('simbathesailor_useWhatChangedImport'),
                    SOURCE: t.stringLiteral('@simbathesailor/use-what-changed')
                  });

                  try {
                    path.unshiftContainer('body', _ast);
                  } catch (e) {
                    console.error('@simbathesailor-uwc-debug error adding import', e);
                  }

                  state.isDoneAddingImport = true;
                } ////


                state.lowerlimituwcdebug = commentObj.loc.start.line;
                uwcDebugBelowEncountered = true;
              }
            });
          } catch (e) {
            console.error('@simbathesailor-uwc-debug error', e);
          }
        }
      }
    }
  };
}

module.exports = Test;
//# sourceMappingURL=babel-plugin-use-what-changed.esm.js.map
